/*
-----------------------------------------------------
StatsStructGen.py 1.2

This file was autogenerated with run cmd:
  "gen_scripts/StatsStructGen.py --packagename=org.frc836.database --classname=SuperScoutStats --tablename=superscout_data_2025 --infile=FRC_Scouting_Server/scouting.sql --outfile=app/src/main/java/org/frc836/database/SuperScoutStats.java --gameinfocol=auto_barge_zone_id --gameinfocol=auto_first_face_id --gameinfocol=auto_ground_face_id --gameinfocol=auto_feeder_station_id"

python version info:
  3.13.1 (main, Dec  4 2024, 18:05:56) [GCC 14.2.1 20240910]

Please take heed of modifying unnecessarily
-----------------------------------------------------
*/

package org.frc836.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import org.frc836.database.FRCScoutingContract.SUPERSCOUT_DATA_2025_Entry;
import org.json.JSONException;
import org.json.JSONObject;
import java.util.Date;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

public class SuperScoutStats {


    public String event_id;
    public int team_id;
    public int match_id;
    public boolean practice_match;
    public String position_id;
    public int robot_drive_speed;
    public double time_to_opp_algae;
    public int coral_intake_speed_ground;
    public int coral_intake_speed_station;
    public int algae_intake_speed_ground;
    public int algae_intake_speed_reef;
    public int opportunistic_defense;
    public int algae_removal_speed;
    public int net_scoring_speed;
    public int processor_scoring_speed;
    public int l1_scoring_speed;
    public int l2_l3_scoring_speed;
    public int l4_scoring_speed;
    public boolean l2_l3_difference;
    public boolean easily_defended;
    public int tippy;
    public String notes;
    

    public static final String TABLE_NAME = SUPERSCOUT_DATA_2025_Entry.TABLE_NAME;
    public static final String COLUMN_NAME_ID = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_ID;
    public static final String COLUMN_NAME_EVENT_ID = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_EVENT_ID;
    public static final String COLUMN_NAME_TEAM_ID = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_TEAM_ID;
    public static final String COLUMN_NAME_MATCH_ID = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_MATCH_ID;
    public static final String COLUMN_NAME_PRACTICE_MATCH = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_PRACTICE_MATCH;
    public static final String COLUMN_NAME_POSITION_ID = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_POSITION_ID;
    public static final String COLUMN_NAME_ROBOT_DRIVE_SPEED = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_ROBOT_DRIVE_SPEED;
    public static final String COLUMN_NAME_TIME_TO_OPP_ALGAE = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_TIME_TO_OPP_ALGAE;
    public static final String COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND;
    public static final String COLUMN_NAME_CORAL_INTAKE_SPEED_STATION = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_CORAL_INTAKE_SPEED_STATION;
    public static final String COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND;
    public static final String COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF;
    public static final String COLUMN_NAME_OPPORTUNISTIC_DEFENSE = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_OPPORTUNISTIC_DEFENSE;
    public static final String COLUMN_NAME_ALGAE_REMOVAL_SPEED = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_ALGAE_REMOVAL_SPEED;
    public static final String COLUMN_NAME_NET_SCORING_SPEED = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_NET_SCORING_SPEED;
    public static final String COLUMN_NAME_PROCESSOR_SCORING_SPEED = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_PROCESSOR_SCORING_SPEED;
    public static final String COLUMN_NAME_L1_SCORING_SPEED = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_L1_SCORING_SPEED;
    public static final String COLUMN_NAME_L2_L3_SCORING_SPEED = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_L2_L3_SCORING_SPEED;
    public static final String COLUMN_NAME_L4_SCORING_SPEED = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_L4_SCORING_SPEED;
    public static final String COLUMN_NAME_L2_L3_DIFFERENCE = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_L2_L3_DIFFERENCE;
    public static final String COLUMN_NAME_EASILY_DEFENDED = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_EASILY_DEFENDED;
    public static final String COLUMN_NAME_TIPPY = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_TIPPY;
    public static final String COLUMN_NAME_NOTES = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_NOTES;
    public static final String COLUMN_NAME_INVALID = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_INVALID;
    public static final String COLUMN_NAME_TIMESTAMP = SUPERSCOUT_DATA_2025_Entry.COLUMN_NAME_TIMESTAMP;
    

    public SuperScoutStats() {
        init();
    }
    
    public void init() {
        event_id = "";
        team_id = 0;
        match_id = 0;
        practice_match = false;
        position_id = "Red 1";
        robot_drive_speed = 0;
        time_to_opp_algae = 0;
        coral_intake_speed_ground = 0;
        coral_intake_speed_station = 0;
        algae_intake_speed_ground = 0;
        algae_intake_speed_reef = 0;
        opportunistic_defense = 0;
        algae_removal_speed = 0;
        net_scoring_speed = 0;
        processor_scoring_speed = 0;
        l1_scoring_speed = 0;
        l2_l3_scoring_speed = 0;
        l4_scoring_speed = 0;
        l2_l3_difference = false;
        easily_defended = false;
        tippy = 0;
        notes = "";
    }
    
    public SuperScoutStats(int team, String event, int match) {
        init();
        this.team_id = team;
        this.event_id = event;
        this.match_id = match;
    }
    
    public SuperScoutStats(int team, String event, int match, boolean practice) {
        init();
        this.team_id = team;
        this.event_id = event;
        this.match_id = match;
        this.practice_match = practice;
    }

    public void copyFrom(SuperScoutStats other) {
        this.event_id = other.event_id;
        this.team_id = other.team_id;
        this.match_id = other.match_id;
        this.practice_match = other.practice_match;
        this.position_id = other.position_id;
        this.robot_drive_speed = other.robot_drive_speed;
        this.time_to_opp_algae = other.time_to_opp_algae;
        this.coral_intake_speed_ground = other.coral_intake_speed_ground;
        this.coral_intake_speed_station = other.coral_intake_speed_station;
        this.algae_intake_speed_ground = other.algae_intake_speed_ground;
        this.algae_intake_speed_reef = other.algae_intake_speed_reef;
        this.opportunistic_defense = other.opportunistic_defense;
        this.algae_removal_speed = other.algae_removal_speed;
        this.net_scoring_speed = other.net_scoring_speed;
        this.processor_scoring_speed = other.processor_scoring_speed;
        this.l1_scoring_speed = other.l1_scoring_speed;
        this.l2_l3_scoring_speed = other.l2_l3_scoring_speed;
        this.l4_scoring_speed = other.l4_scoring_speed;
        this.l2_l3_difference = other.l2_l3_difference;
        this.easily_defended = other.easily_defended;
        this.tippy = other.tippy;
        this.notes = other.notes;
    
    }

    public ContentValues getValues(SQLiteDatabase database) {
        ContentValues vals = new ContentValues();
        long ev = DB.getEventIdFromName(event_id, database);
        vals.put(COLUMN_NAME_ID, ev * 10000000 + (long)match_id * 10000 + team_id);
        vals.put(COLUMN_NAME_EVENT_ID, ev);
        vals.put(COLUMN_NAME_TEAM_ID, team_id);
        vals.put(COLUMN_NAME_MATCH_ID, match_id);
        vals.put(COLUMN_NAME_PRACTICE_MATCH, practice_match ? 1 : 0);
        vals.put(COLUMN_NAME_POSITION_ID, DB.getPosIdFromName(position_id, database));
        vals.put(COLUMN_NAME_ROBOT_DRIVE_SPEED, robot_drive_speed);
        vals.put(COLUMN_NAME_TIME_TO_OPP_ALGAE, time_to_opp_algae);
        vals.put(COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND, coral_intake_speed_ground);
        vals.put(COLUMN_NAME_CORAL_INTAKE_SPEED_STATION, coral_intake_speed_station);
        vals.put(COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND, algae_intake_speed_ground);
        vals.put(COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF, algae_intake_speed_reef);
        vals.put(COLUMN_NAME_OPPORTUNISTIC_DEFENSE, opportunistic_defense);
        vals.put(COLUMN_NAME_ALGAE_REMOVAL_SPEED, algae_removal_speed);
        vals.put(COLUMN_NAME_NET_SCORING_SPEED, net_scoring_speed);
        vals.put(COLUMN_NAME_PROCESSOR_SCORING_SPEED, processor_scoring_speed);
        vals.put(COLUMN_NAME_L1_SCORING_SPEED, l1_scoring_speed);
        vals.put(COLUMN_NAME_L2_L3_SCORING_SPEED, l2_l3_scoring_speed);
        vals.put(COLUMN_NAME_L4_SCORING_SPEED, l4_scoring_speed);
        vals.put(COLUMN_NAME_L2_L3_DIFFERENCE, l2_l3_difference ? 1 : 0);
        vals.put(COLUMN_NAME_EASILY_DEFENDED, easily_defended ? 1 : 0);
        vals.put(COLUMN_NAME_TIPPY, tippy);
        vals.put(COLUMN_NAME_NOTES, notes);
        vals.put(COLUMN_NAME_INVALID, 1);
    
        return vals;
    }

    public void fromCursor(Cursor c, DB db, SQLiteDatabase database) {
        fromCursor(c, db, database, 0);
    }
    
    public void fromCursor(Cursor c, DB db, SQLiteDatabase database, int pos) {
        c.moveToPosition(pos);
        event_id = DB.getEventNameFromId(c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_EVENT_ID)), database);
        team_id = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_TEAM_ID));
        match_id = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_MATCH_ID));
        practice_match = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_PRACTICE_MATCH)) != 0;
        position_id = DB.getPosNameFromId(c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_POSITION_ID)), database);
        robot_drive_speed = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_ROBOT_DRIVE_SPEED));
        time_to_opp_algae = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_TIME_TO_OPP_ALGAE));
        coral_intake_speed_ground = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND));
        coral_intake_speed_station = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CORAL_INTAKE_SPEED_STATION));
        algae_intake_speed_ground = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND));
        algae_intake_speed_reef = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF));
        opportunistic_defense = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_OPPORTUNISTIC_DEFENSE));
        algae_removal_speed = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_ALGAE_REMOVAL_SPEED));
        net_scoring_speed = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_NET_SCORING_SPEED));
        processor_scoring_speed = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_PROCESSOR_SCORING_SPEED));
        l1_scoring_speed = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_L1_SCORING_SPEED));
        l2_l3_scoring_speed = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_L2_L3_SCORING_SPEED));
        l4_scoring_speed = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_L4_SCORING_SPEED));
        l2_l3_difference = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_L2_L3_DIFFERENCE)) != 0;
        easily_defended = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_EASILY_DEFENDED)) != 0;
        tippy = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_TIPPY));
        notes = c.getString(c.getColumnIndexOrThrow(COLUMN_NAME_NOTES));
    }

    public static String[] getProjection() {
        List<String> temp = new ArrayList<String>(22);
        temp.add(COLUMN_NAME_EVENT_ID);
        temp.add(COLUMN_NAME_TEAM_ID);
        temp.add(COLUMN_NAME_MATCH_ID);
        temp.add(COLUMN_NAME_PRACTICE_MATCH);
        temp.add(COLUMN_NAME_POSITION_ID);
        temp.add(COLUMN_NAME_ROBOT_DRIVE_SPEED);
        temp.add(COLUMN_NAME_TIME_TO_OPP_ALGAE);
        temp.add(COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND);
        temp.add(COLUMN_NAME_CORAL_INTAKE_SPEED_STATION);
        temp.add(COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND);
        temp.add(COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF);
        temp.add(COLUMN_NAME_OPPORTUNISTIC_DEFENSE);
        temp.add(COLUMN_NAME_ALGAE_REMOVAL_SPEED);
        temp.add(COLUMN_NAME_NET_SCORING_SPEED);
        temp.add(COLUMN_NAME_PROCESSOR_SCORING_SPEED);
        temp.add(COLUMN_NAME_L1_SCORING_SPEED);
        temp.add(COLUMN_NAME_L2_L3_SCORING_SPEED);
        temp.add(COLUMN_NAME_L4_SCORING_SPEED);
        temp.add(COLUMN_NAME_L2_L3_DIFFERENCE);
        temp.add(COLUMN_NAME_EASILY_DEFENDED);
        temp.add(COLUMN_NAME_TIPPY);
        temp.add(COLUMN_NAME_NOTES);
        String[] projection = new String[temp.size()];
        return temp.toArray(projection);
    }

    public static boolean isTextField(String column_name) {
        if (COLUMN_NAME_NOTES.equalsIgnoreCase(column_name)) return true;
    
        return false;
    }

    public static boolean isGameInfoLookup(String column_name) {
        return false;
    }

    public static ContentValues jsonToCV(JSONObject json) throws JSONException {
        ContentValues vals = new ContentValues();
        vals.put(COLUMN_NAME_ID, json.has(COLUMN_NAME_ID) ? json.getInt(COLUMN_NAME_ID) : 0);
        vals.put(COLUMN_NAME_EVENT_ID, json.has(COLUMN_NAME_EVENT_ID) ? json.getInt(COLUMN_NAME_EVENT_ID) : 0);
        vals.put(COLUMN_NAME_TEAM_ID, json.has(COLUMN_NAME_TEAM_ID) ? json.getInt(COLUMN_NAME_TEAM_ID) : 0);
        vals.put(COLUMN_NAME_MATCH_ID, json.has(COLUMN_NAME_MATCH_ID) ? json.getInt(COLUMN_NAME_MATCH_ID) : 0);
        vals.put(COLUMN_NAME_PRACTICE_MATCH, json.has(COLUMN_NAME_PRACTICE_MATCH) ? json.getInt(COLUMN_NAME_PRACTICE_MATCH) : 0);
        vals.put(COLUMN_NAME_POSITION_ID, json.has(COLUMN_NAME_POSITION_ID) ? json.getInt(COLUMN_NAME_POSITION_ID) : 0);
        vals.put(COLUMN_NAME_ROBOT_DRIVE_SPEED, json.has(COLUMN_NAME_ROBOT_DRIVE_SPEED) ? json.getInt(COLUMN_NAME_ROBOT_DRIVE_SPEED) : 0);
        vals.put(COLUMN_NAME_TIME_TO_OPP_ALGAE, json.has(COLUMN_NAME_TIME_TO_OPP_ALGAE) ? json.getInt(COLUMN_NAME_TIME_TO_OPP_ALGAE) : 0);
        vals.put(COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND, json.has(COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND) ? json.getInt(COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND) : 0);
        vals.put(COLUMN_NAME_CORAL_INTAKE_SPEED_STATION, json.has(COLUMN_NAME_CORAL_INTAKE_SPEED_STATION) ? json.getInt(COLUMN_NAME_CORAL_INTAKE_SPEED_STATION) : 0);
        vals.put(COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND, json.has(COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND) ? json.getInt(COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND) : 0);
        vals.put(COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF, json.has(COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF) ? json.getInt(COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF) : 0);
        vals.put(COLUMN_NAME_OPPORTUNISTIC_DEFENSE, json.has(COLUMN_NAME_OPPORTUNISTIC_DEFENSE) ? json.getInt(COLUMN_NAME_OPPORTUNISTIC_DEFENSE) : 0);
        vals.put(COLUMN_NAME_ALGAE_REMOVAL_SPEED, json.has(COLUMN_NAME_ALGAE_REMOVAL_SPEED) ? json.getInt(COLUMN_NAME_ALGAE_REMOVAL_SPEED) : 0);
        vals.put(COLUMN_NAME_NET_SCORING_SPEED, json.has(COLUMN_NAME_NET_SCORING_SPEED) ? json.getInt(COLUMN_NAME_NET_SCORING_SPEED) : 0);
        vals.put(COLUMN_NAME_PROCESSOR_SCORING_SPEED, json.has(COLUMN_NAME_PROCESSOR_SCORING_SPEED) ? json.getInt(COLUMN_NAME_PROCESSOR_SCORING_SPEED) : 0);
        vals.put(COLUMN_NAME_L1_SCORING_SPEED, json.has(COLUMN_NAME_L1_SCORING_SPEED) ? json.getInt(COLUMN_NAME_L1_SCORING_SPEED) : 0);
        vals.put(COLUMN_NAME_L2_L3_SCORING_SPEED, json.has(COLUMN_NAME_L2_L3_SCORING_SPEED) ? json.getInt(COLUMN_NAME_L2_L3_SCORING_SPEED) : 0);
        vals.put(COLUMN_NAME_L4_SCORING_SPEED, json.has(COLUMN_NAME_L4_SCORING_SPEED) ? json.getInt(COLUMN_NAME_L4_SCORING_SPEED) : 0);
        vals.put(COLUMN_NAME_L2_L3_DIFFERENCE, json.has(COLUMN_NAME_L2_L3_DIFFERENCE) ? json.getInt(COLUMN_NAME_L2_L3_DIFFERENCE) : 0);
        vals.put(COLUMN_NAME_EASILY_DEFENDED, json.has(COLUMN_NAME_EASILY_DEFENDED) ? json.getInt(COLUMN_NAME_EASILY_DEFENDED) : 0);
        vals.put(COLUMN_NAME_TIPPY, json.has(COLUMN_NAME_TIPPY) ? json.getInt(COLUMN_NAME_TIPPY) : 0);
        vals.put(COLUMN_NAME_NOTES, json.has(COLUMN_NAME_NOTES) ? json.getString(COLUMN_NAME_NOTES) : "");
        vals.put(COLUMN_NAME_INVALID, 0);
        vals.put(COLUMN_NAME_TIMESTAMP, DB.dateParser.format(new Date(json.getLong(COLUMN_NAME_TIMESTAMP) * 1000)));
        return vals;
    }

    public LinkedHashMap<String,String> getDisplayData() {
        LinkedHashMap<String,String> vals = new LinkedHashMap<String,String>();
        vals.put( COLUMN_NAME_EVENT_ID, event_id);
        vals.put( COLUMN_NAME_TEAM_ID, String.valueOf(team_id));
        vals.put( COLUMN_NAME_MATCH_ID, String.valueOf(match_id));
        vals.put( COLUMN_NAME_PRACTICE_MATCH, String.valueOf(practice_match ? 1 : 0));
        vals.put( COLUMN_NAME_POSITION_ID, position_id);
        vals.put( COLUMN_NAME_ROBOT_DRIVE_SPEED, String.valueOf(robot_drive_speed));
        vals.put( COLUMN_NAME_CORAL_INTAKE_SPEED_GROUND, String.valueOf(coral_intake_speed_ground));
        vals.put( COLUMN_NAME_CORAL_INTAKE_SPEED_STATION, String.valueOf(coral_intake_speed_station));
        vals.put( COLUMN_NAME_ALGAE_INTAKE_SPEED_GROUND, String.valueOf(algae_intake_speed_ground));
        vals.put( COLUMN_NAME_ALGAE_INTAKE_SPEED_REEF, String.valueOf(algae_intake_speed_reef));
        vals.put( COLUMN_NAME_OPPORTUNISTIC_DEFENSE, String.valueOf(opportunistic_defense));
        vals.put( COLUMN_NAME_ALGAE_REMOVAL_SPEED, String.valueOf(algae_removal_speed));
        vals.put( COLUMN_NAME_NET_SCORING_SPEED, String.valueOf(net_scoring_speed));
        vals.put( COLUMN_NAME_PROCESSOR_SCORING_SPEED, String.valueOf(processor_scoring_speed));
        vals.put( COLUMN_NAME_L1_SCORING_SPEED, String.valueOf(l1_scoring_speed));
        vals.put( COLUMN_NAME_L2_L3_SCORING_SPEED, String.valueOf(l2_l3_scoring_speed));
        vals.put( COLUMN_NAME_L4_SCORING_SPEED, String.valueOf(l4_scoring_speed));
        vals.put( COLUMN_NAME_L2_L3_DIFFERENCE, String.valueOf(l2_l3_difference ? 1 : 0));
        vals.put( COLUMN_NAME_EASILY_DEFENDED, String.valueOf(easily_defended ? 1 : 0));
        vals.put( COLUMN_NAME_TIPPY, String.valueOf(tippy));
        vals.put( COLUMN_NAME_NOTES, notes);
        return vals;
    }

}